--- 

title       : The Big Data Analytics Landscape with Applications in Augmented Knowledge Discovery
subtitle    : 
author      : Michael Kane with Peter Rabinowitz
job         : 
framework   : io2012        # {io2012, html5slides, shower, dzslides, ...}
highlighter : highlight.js  # {highlight.js, prettify, highlight}
hitheme     : tomorrow      # 
widgets     : [mathjax]            # {mathjax, quiz, bootstrap}
mode        : selfcontained # {standalone, draft}
---

## Goals for this talk

<style>
  .bottom-two {
     margin-bottom: 2cm;
  }
</style>

<style>
  .bottom-one {
     margin-bottom: 1cm;
  }
</style>


<style type="text/css">
  .centeredImage
    {
    text-align:center;
    margin-top:0px;
    margin-bottom:0px;
    padding:0px;
    }
</style>

<p class = "bottom-one"></p>


<span style="font-size: 28px;"> 
1. Provide a navigable view of the Big Data landscape
</span>

<p class = "bottom-one"></p>

<span style="font-size: 28px;"> 
2. Show off some of the work for the Round 11 Grand Challenge
</span>

<p class = "bottom-one"></p>

<p class="centeredImage">
<img src="grafton.jpg" alt="" vspace=20 width=900>
</p>

--- .class #id 

## Who am I?

<p class = "bottom-one"></p>

<span style="font-size: 32px;"> 
Research Faculty in Biostatistics at Yale University
</span>

<p class = "bottom-one"></p>

<span style="font-size: 32px;"> 
Interested in scalable machine learning and applied probability
</span>

<p class = "bottom-one"></p>

<span style="font-size: 32px;"> 
Background in computing, machine learning, and statistics
</span>

<p class = "bottom-one"></p>

<span style="font-size: 32px;"> 
Track record
</span>
- <span style="font-size: 28px;"> 2010 ASA Chamber's Prize </span>
- <span style="font-size: 28px;"> 2012 DARPA XDATA Initiative </span>
- <span style="font-size: 28px;"> 2013 Grand Challenge Exploration Round 11 </span>

---

## Business Collaborators

<p class = "bottom-two"></p>

<span style="font-size: 38px;"> 
AT&T Labs-Research
</span>

<p class = "bottom-one"></p>

<span style="font-size: 38px;"> 
Genentech
</span>

<p class = "bottom-one"></p>

<span style="font-size: 38px;"> 
Paradigm4
</span>

<p class = "bottom-one"></p>

<span style="font-size: 38px;"> 
Sybase
</span>

<p class = "bottom-one"></p>

<span style="font-size: 38px;"> 
Oracle
</span>

---

## Inspiration for this talk

<p class = "bottom-one"></p>

<span style="font-size: 38px;"> 
2013 I was asked to be an editor for The Handbook of Big Data (C&H)
</span>

<span style="font-size: 38px;"> 
We need to understand how methodologies and theories of Big Data fit 
together.
</span>

<p class = "bottom-one"></p>

<p class="centeredImage">
<img src="jigsaw.jpg" alt="" vspace=20 width=350>
</p>

---

## Indexing vs. Learning (Model Fitting)

<p class="centeredImage">
<img src="foursquare.png" alt="" vspace=20 width=850>
</p>

---

## Indexing vs. Learning

<p class = "bottom-two"></p>

<span style="font-size: 38px;"> Indexing </span>
- <span style="font-size: 32px;"> Goal is efficient retrieval of data </span>
- <span style="font-size: 32px;"> Can used to make big data into small data </span>

<p class = "bottom-one"></p>

<span style="font-size: 38px;"> Learning  </span>
- <span style="font-size: 32px;">Goal is understanding the structure of data </span>
- <span style="font-size: 32px;">Model relationships within data </span>

---

## The Social Impact of Big Data

<p class = "bottom-two"></p>

<span style="font-size: 38px;">
We are at a point in human history where we can now collect far more data 
than we can analyze in a reasonable amount of time.
</span>

<p class = "bottom-one"></p>

<span style="font-size: 38px;">
The goal of big data analytics is to provide new ways of
making sense of enormous amounts of digital information and make
meaningful (and positive) impacts in areas such as science and business
</span>

--- 

## Should we characterize big data with the 4 V's?

<p class="centeredImage">
<img src="v4.jpg" alt="" vspace=20 width=900>
</p>

---

## Should we characterize by volume?

<p class = "bottom-two"></p>

<span style="font-size: 38px;">
A big data set in genetics is order 10's of gigabytes.
</span>

<p class = "bottom-two"></p>

<span style="font-size: 38px;">
A big data set in advertisement can be order petabytes or even more.
</span>

---

## An alternative characterization

<p class = "bottom-two"></p>

<span style="font-size: 38px;">
A data set is "big" if the computational, methodological, and theoretical
approaches required to understand its structure have to be reimagined because
of its vastness and new approaches need to be developed to extract 
information from it. -Casey King
</span>

<p class = "bottom-two"></p>

<span style="font-size: 38px;">
"They extend their procedures without examining their principles" -Edgar
Allen Poe, The Purloined Letter
</span>

---

## What are the analytics challenges that have inspired "reimagining"?

<p class = "bottom-two"></p>

<span style="font-size: 38px;">
1. The rapid accumulation of data 
</span>

<p class = "bottom-one"></p>

<span style="font-size: 38px;">
2. Many samples 
</span>

<p class = "bottom-one"></p>

<span style="font-size: 38px;">
3. Many measurements per sample
</span>

<p class = "bottom-one"></p>

<span style="font-size: 38px;">
4. Many samples and many measurements per sample
</span>

<p class = "bottom-one"></p>

<span style="font-size: 38px;">
5. Unstructured and complex samples
</span>

---

## Rapid Accumulation of Data: Facebook

<span style="font-size: 32px;">
As of August 2012 [Facebook stores more than 100 *petabytes*](http://news.cnet.com/8301-1023_3-57498531-93/facebook-processes-more-than-500-tb-of-data-daily/) of disk space.
</span>

<span style="font-size: 32px;">
This is 900720000000000000 (9e17) bits.
</span>

<span style="font-size: 32px;">
If a bit were an inch wide: 14215900000000 (1.4e13) miles
- The sun is only about 92000000 (9.2e7) miles away
- 2.41828705 light years
</span>

<span style="font-size: 32px;">
The *daily* breakdown
</span>
- 2.7 billion likes made daily on and off of the Facebook site
- 300 million photos uploaded
- 70,000 queries executed by people and automated systems
- 500+ terabytes of new data "ingested"

---

## The Cohen Conjecture

<p class="centeredImage">
<img src="dave.jpg" alt="" vspace=20 width=200 >
</p>

<p class = "bottom-one"></p>

<span style="font-size: 32px;">
"For increasingly large sets of data, access to individual samples 
decreases exponentially over time." -David Cohen
</span>

<span style="font-size: 32px;">
Videos and photographs shared over Facebook are almost never accessed 
after one day of being posted.
</span>

<span style="font-size: 32px;">
Amazon is betting on this phenomenon with [AWS Glacier](http://aws.amazon.com/glacier/).
</span>

---

## Many Samples

<p class = "bottom-two"></p>

<span style="font-size: 32px;">
Many big data sets are "tall and skinny".
</span>
- <span style="font-size: 28px;">Large number of measurements</span>
- <span style="font-size: 28px;">Each measurement includes relatively few features</span>

<p class = "bottom-one"></p>

<span style="font-size: 32px;">
Tend to be very large in total volume
</span>

<p class = "bottom-one"></p>

<span style="font-size: 32px;"> Example: The Airline On-time Performance </span>
- <span style="font-size: 28px;">All commercial domestic flights from October 1987 to April 2008 </span>
- <span style="font-size: 28px;">About 120 million commercial domestic flights </span>
- <span style="font-size: 28px;">29 features (date, flight time, arrival delay, etc.) </span>

---

## The Tall-Skinny Representation 

<p class = "bottom-one"></p>

<p class="centeredImage">
<img src="TallSkinny.jpg" alt="" vspace=20 width=300>
</p>

---

## Tall-Skinny Challenges are Computational

<p class = "bottom-two"></p>

<span style="font-size: 32px;">
Learning (model fitting) algorithms do better with more data
</span>

<p class = "bottom-two"></p>

<span style="font-size: 32px;">
We essentially have the population
</span>

<p class = "bottom-two"></p>

<span style="font-size: 32px;">
Approach is generally to do things on individual blocks and aggregate the
results
</span>

---

## "Chunk and Add"

$$
\widehat{\beta} = \left( X^T X \right)^{-1} X^T Y
$$

<span style="font-size: 32px;">
Algorithm for calculating the OLS slope estimate:
</span>

- Let $X_i$ and $Y_i$ be the $i$th block of $X$ and $Y$.
- Let $r$ be the number of blocks.
- Compute $X^T X$ as
$$
\sum_{i=1}^{r} X_i^T X_i
$$
- Invert $X^T X$
- Compute $X^T Y$ similarly
- Multiply the results to get the slope coefficients.

---

## Many Features

<p class = "bottom-two"></p>

<span style="font-size: 32px;">
Number of features per sample is much larger than the
number of samples
</span>

<p class = "bottom-two"></p>

<span style="font-size: 32px;">
Example: Genome Studies
</span>
- <span style="font-size: 28px;">Human genome is 3.2 billion base pairs</span>
- <span style="font-size: 28px;">A "large" genome study has thousands of people</span>

<p class = "bottom-two"></p>

<span style="font-size: 32px;">
Tend to be smaller in total volume
</span>

---

## Many-Feature Challenges are Statistical 

<p class = "bottom-two"></p>


```r
require(foreach)
y <- rnorm(100)
p_values <- foreach(i = 1:1000, .combine = c) %do% {
    x <- rnorm(100)
    s <- summary(lm(y ~ x))
    s$coefficients[2, 4]
}
sum(p_values < 0.05)
```

```
## [1] 56
```


---

## Approaches to Many-Feature Challenges

<p class = "bottom-one"></p>

1. <span style="font-size: 28px;">Look for highly-significant features</span>
  - Bonferonni/Sidak correction
  - Use an accepted (less stringent) p-value

2. <span style="font-size: 28px;">False discovery rate</span>
  - Get the rate at which your "significant" features are not significant
  - Doesn't give you features of interest

3. <span style="font-size: 28px;">Dimension reduction</span>
  - Project the data into a new feature space and perform analysis
  - Transformation can identify sets of features that are significant

---

## Many-Sample-Many-Feature ("Squarish") Challenges 

<p class = "bottom-one"></p>
<span style="font-size: 28px;">
Data sets that are large both in the number of rows and number of columns
</span>

<p class = "bottom-one"></p>
<span style="font-size: 28px;">
Generally show connections between things
</span>

<p class = "bottom-one"></p>
<span style="font-size: 28px;">
Example: The Netflix Data Set
</span>
- 480,189 users
- 17,770 movies
- An incidence matrix of ratings has 8,532,958,530 entries

---

## Tall-Fat Data Sets are Sparse

<p class = "bottom-two"></p>

<span style="font-size: 28px;">
Each person only rated about 200 movies
</span>

<p class = "bottom-one"></p>

<span style="font-size: 28px;">
This corresponds to 100,480,507 non-zero entries
</span>

<p class = "bottom-one"></p>

<span style="font-size: 28px;">
The matrix is about 99% sparse
</span>

<p class = "bottom-one"></p>

<span style="font-size: 28px;">
We only need about 375 MB to store this.
</span>

---


## Complex data is usually text

```{xml}
<Article PubModel="Print-Electronic">
    <Journal>
        <ISSN IssnType="Electronic">1551-4005</ISSN>
        <JournalIssue CitedMedium="Internet">
            <Volume>12</Volume>
            <Issue>24</Issue>
            <PubDate>
                <Year>2013</Year>
                <Month>Oct</Month>
                <Day>21</Day>
            </PubDate>
        </JournalIssue>
        <Title>Cell cycle (Georgetown, Tex.)</Title>
        <ISOAbbreviation>Cell Cycle</ISOAbbreviation>
    </Journal>
```

---

## Peter's an My Gates Proposal

<p class = "bottom-two"></p>

<span style="font-size: 28px;">
The whole of our intellectual understanding about human and animal medicine is 
contained in the literature.
</span>
- <span style="font-size: 28px;">Well-documented</span>
- <span style="font-size: 28px;">Citation information is available</span>

<p class = "bottom-one"></p>

<span style="font-size: 28px;">
Reading papers is hard.
</span>
- <span style="font-size: 28px;">Time consuming</span>
- <span style="font-size: 28px;">Hard to know what to read</span>

---

## Provide a Panoramic View of the Literature

<p class = "bottom-two"></p>

<span style="font-size: 28px;">
Pubmed query results are data
</span>

<p class = "bottom-one"></p>

<span style="font-size: 28px;">
Data can be clustered according to their content
</span>

<p class = "bottom-one"></p>

<span style="font-size: 28px;">
How is this different than a keyword search?
</span>
- <span style="font-size: 28px;">We can visualize the "closeness" of any two documents</span>
- <span style="font-size: 28px;">Query provides a context for understanding interrelationships</span>

---

## RVF Demo

---

## Is 1,200 RVF Documents "Big"?


<p class="centeredImage">
<img src="bigdata.jpg" alt="" vspace=20 width=700>
</p>


---

## Project Vision

<p class = "bottom-two"></p>

<span style="font-size: 28px;">
Making the RVF Challenge Bigger 
</span>
- <span style="font-size: 28px;">Google Scholar has about 26,000 documents</span>
- <span style="font-size: 28px;">Integrate genomics databases</span>
- <span style="font-size: 28px;">Provide a interactive web application</span>

<p class = "bottom-one"></p>

<span style="font-size: 28px;">
Provide custom document search, organization, and exploration</span>
- <span style="font-size: 28px;">Increase research awareness</span>
- <span style="font-size: 28px;">Jumpstart interdisciplinary research</span>

---

## Project Relevance

<p class="centeredImage">
<img src="memex.png" alt="" vspace=20 width=900>
</p>

---

## Conclusions

<p class="centeredImage">
<img src="whiteface.jpg" alt="" vspace=20 width=900>
</p>



